Bug 1315871 - Review Request: python-mdp - Library for building data processing pipelines for machine learning
Review Request: python-mdp - Library for building data processing pipelines f...
Status: CLOSED CURRENTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Jonathan Underwood
Fedora Extras Quality Assurance
:
: 807867 (view as bug list)
Depends On:
Blocks: fedora-neuro
  Show dependency treegraph
 
Reported: 2016-03-08 15:27 EST by Zbigniew Jędrzejewski-Szmek
Modified: 2016-03-09 16:14 EST (History)
3 users (show)

See Also:
Fixed In Version: python-mdp-3.5-2.fc22
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-03-09 16:11:44 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
jonathan.underwood: fedora‑review+


Attachments (Terms of Use)
Build failure on rawhide - failure in tests (278.57 KB, text/plain)
2016-03-09 05:46 EST, Jonathan Underwood
no flags Details

  None (edit)
Description Zbigniew Jędrzejewski-Szmek 2016-03-08 15:27:06 EST
Spec URL: http://in.waw.pl/~zbyszek/fedora/python-mdp.spec
SRPM URL: http://in.waw.pl/~zbyszek/fedora/python-mdp-3.5-1.fc25.src.rpm
Fedora Account System Username: zbyszek
Description:
The Modular toolkit for Data Processing (MDP) package is a library of
widely used data processing algorithms, and the possibility to combine
them together to form pipelines for building more complex data
processing software. MDP has been designed to be used as-is and as a
framework for scientific data processing development.

From the user’s perspective, MDP consists of a collection of units,
which process data. For example, these include algorithms for
supervised and unsupervised learning, principal and independent
components analysis and classification. These units can be chained
into data processing flows, to create pipelines as well as more
complex feed-forward network architectures. Given a set of input data,
MDP takes care of training and executing all nodes in the network in
the correct order and passing intermediate data between the
nodes. This allows the user to specify complex algorithms as a series
of simpler data processing steps.

--
This is an old package, but it still finds use in the community because
some of the algorithms are not implemented anywhere else. A new version
has just been released so I though it a good time to add this to Fedora.
Comment 1 Zbigniew Jędrzejewski-Szmek 2016-03-08 15:31:29 EST
*** Bug 807867 has been marked as a duplicate of this bug. ***
Comment 3 Jonathan Underwood 2016-03-09 05:46 EST
Created attachment 1134451 [details]
Build failure on rawhide - failure in tests

Build is failing on rawhide.
Comment 4 Jonathan Underwood 2016-03-09 06:29:36 EST
This review was done with an F23 build, since the rawhide build fails,
and F24 is currently broken with regard to mock builds (some packages
are unsigned).

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======

1/ The spec file in the SRPM and the spec file given in the URL are
   different! Sort this out.

2/ Build is failing on rawhide (build on rawhide is a blocker)

3/ Remove .buildinfo files from docs (I see this is done in one of the
specs, but not the other!)


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "BSD (3 clause)", "GPL (v3 or later)", "Unknown or generated".
     223 files have unknown license. Detailed output of licensecheck in
     /home/jgu/Fedora/1315871-python-mdp/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 0 bytes in 0 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     python2-mdp , python3-mdp , python-mdp-doc
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[!]: Package should compile and build into binary rpms on all supported
     architectures.

Currently not building on rawhide

[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Spec file according to URL is the same as in SRPM.
     Note: Spec file as given by url is not the same as in SRPM (see
     attached diff).
     See: (this test has no URL)
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).


Rpmlint
-------
Checking: python2-mdp-3.5-1.fc23.noarch.rpm
          python3-mdp-3.5-1.fc23.noarch.rpm
          python-mdp-doc-3.5-1.fc23.noarch.rpm
          python-mdp-3.5-1.fc23.src.rpm
python2-mdp.noarch: W: no-documentation
python3-mdp.noarch: W: no-documentation
python-mdp-doc.noarch: W: file-not-utf8 /usr/share/doc/python-mdp/html/_static/EuroScipy2010MDPTalk.zip
python-mdp-doc.noarch: W: file-not-utf8 /usr/share/doc/python-mdp/html/_static/Bochum2009TalkPythonMDP.zip
python-mdp-doc.noarch: W: hidden-file-or-dir /usr/share/doc/python-mdp/html/.buildinfo

---> This needs to be removed.

python-mdp-doc.noarch: W: file-not-utf8 /usr/share/doc/python-mdp/html/_static/DLRCologne2009TalkGerman.zip
python-mdp-doc.noarch: W: file-not-utf8 /usr/share/doc/python-mdp/html/_static/MDP_BiNet_TU2009.zip
python-mdp-doc.noarch: W: file-not-utf8 /usr/share/doc/python-mdp/html/_static/EuroPython2009MDPTalk.zip
4 packages and 0 specfiles checked; 0 errors, 8 warnings.




Rpmlint (installed packages)
----------------------------
python3-mdp.noarch: W: no-documentation
python-mdp-doc.noarch: W: file-not-utf8 /usr/share/doc/python-mdp/html/_static/MDP_BiNet_TU2009.zip
python-mdp-doc.noarch: W: file-not-utf8 /usr/share/doc/python-mdp/html/_static/DLRCologne2009TalkGerman.zip
python-mdp-doc.noarch: W: file-not-utf8 /usr/share/doc/python-mdp/html/_static/Bochum2009TalkPythonMDP.zip
python-mdp-doc.noarch: W: file-not-utf8 /usr/share/doc/python-mdp/html/_static/EuroScipy2010MDPTalk.zip
python-mdp-doc.noarch: W: hidden-file-or-dir /usr/share/doc/python-mdp/html/.buildinfo

----> this needs to be removed

python-mdp-doc.noarch: W: file-not-utf8 /usr/share/doc/python-mdp/html/_static/EuroPython2009MDPTalk.zip
python2-mdp.noarch: W: no-documentation
3 packages and 0 specfiles checked; 0 errors, 8 warnings.



Diff spec file in url and in SRPM
---------------------------------
--- /home/jgu/Fedora/1315871-python-mdp/srpm/python-mdp.spec	2016-03-09 10:50:16.026833554 +0000
+++ /home/jgu/Fedora/1315871-python-mdp/srpm-unpacked/python-mdp.spec	2016-03-08 20:13:27.000000000 +0000
@@ -65,5 +65,4 @@
 Recommends:  python2-joblib
 Recommends:  python-scikit-learn
-Recommends:  python-pytest
 Provides:    python2-bimdp = %{version}-%{release}
 %{?python_provide:%python_provide python2-mdp}
@@ -80,5 +79,4 @@
 Recommends:  python3-joblib
 Recommends:  python3-scikit-learn
-Recommends:  python3-pytest
 Provides:    python3-bimdp = %{version}-%{release}
 %{?python_provide:%python_provide python3-mdp}
@@ -101,12 +99,10 @@
 %py2_build
 %py3_build
-pushd mdp-docs-MDP-%{version}
-ln -s .. mdp-toolkit
-PYTHONPATH=.. make \
+ln -s .. mdp-docs-MDP-%{version}/mdp-toolkit
+PYTHONPATH=.. make -C mdp-docs-MDP-%{version} \
               MDPTOOLKIT=.. \
               SPHINXBUILD=sphinx-build-%{python3_version} \
               LINKS=local \
               epydoc codesnippet html
-rm build/html/.buildinfo
 
 %install


Requires
--------
python3-mdp (rpmlib, GLIBC filtered):
    python(abi)
    python3-future
    python3-numpy
    python3-scipy

python-mdp-doc (rpmlib, GLIBC filtered):

python2-mdp (rpmlib, GLIBC filtered):
    numpy
    python(abi)
    python2-future
    scipy



Provides
--------
python3-mdp:
    python3-bimdp
    python3-mdp

python-mdp-doc:
    python-mdp-doc

python2-mdp:
    python-bimdp
    python-mdp
    python2-bimdp
    python2-mdp



Source checksums
----------------
https://github.com/mdp-toolkit/mdp-toolkit/archive/MDP-3.5.tar.gz :
  CHECKSUM(SHA256) this package     : 436dc8b300402dc6a55b090e8ea12f7b9e01a9fed3609e0e905bb0b5f6b3cf4c
  CHECKSUM(SHA256) upstream package : 436dc8b300402dc6a55b090e8ea12f7b9e01a9fed3609e0e905bb0b5f6b3cf4c
https://github.com/mdp-toolkit/mdp-docs/archive/MDP-3.5.tar.gz#/MDP-docs-3.5.tar.gz :
  CHECKSUM(SHA256) this package     : a6b3733a50d137af2ec937a8f7637f358244684ba1e286607a10a878b303d42e
  CHECKSUM(SHA256) upstream package : a6b3733a50d137af2ec937a8f7637f358244684ba1e286607a10a878b303d42e


Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -m fedora-23-x86_64 -b 1315871
Buildroot used: fedora-23-x86_64
Active plugins: Python, Generic, Shell-api
Disabled plugins: Java, C/C++, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6
Comment 5 Zbigniew Jędrzejewski-Szmek 2016-03-09 09:01:03 EST
The test is probabilistic and seems to fail randomly. I disabled it.

Spec URL: http://in.waw.pl/~zbyszek/fedora/python-mdp.spec
SRPM URL: http://in.waw.pl/~zbyszek/fedora/python-mdp-3.5-2.fc25.src.rpm
Comment 6 Jonathan Underwood 2016-03-09 09:36:44 EST
(In reply to Zbigniew Jędrzejewski-Szmek from comment #5)
> The test is probabilistic and seems to fail randomly. I disabled it.
> 

You should:
a) Report this as an upstream bug
b) Include a comment in the spec file explaining the test is failing and with a link to the upstream bug report


> Spec URL: http://in.waw.pl/~zbyszek/fedora/python-mdp.spec
> SRPM URL: http://in.waw.pl/~zbyszek/fedora/python-mdp-3.5-2.fc25.src.rpm

OK, looks good to me, other than the above small issue. APPROVED.
Comment 7 Gwyn Ciesla 2016-03-09 15:33:57 EST
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/python-mdp
Comment 8 Zbigniew Jędrzejewski-Szmek 2016-03-09 16:11:44 EST
Thanks you for the review!
Comment 9 Zbigniew Jędrzejewski-Szmek 2016-03-09 16:14:28 EST
I reported the test failure on the mdp mailing list.

Note You need to log in before you can comment on or make changes to this bug.